//---------------------------------------------------------------
//
//  Ce code est librement inspiré de celui de Gabriel STOLTZ (Ecole des Ponts)
//
//---------------------------------------------------------------

clf();

//-------- modes --------
opt = 0;   // 0 = plot3d standard
           // 2 = surfaces de niveau 3d 
           // 1 = surfaces de niveau 2d

//------ pour les traces -------
dx = 0.1;
dy = 0.1;
dx_c = 0.001;
Rx = 4;
Ry = 4;

//-------- fonction -------------

coef = grand(1,3,'unf',-5,5);
// coef = [0 1 0]
// coef = [1 0 0]
disp(coef(2)^2-4*coef(1)*coef(3), 'b^2-4*a*c= '); 
disp(coef(1)+coef(3), 'a+c= '); 

function z = V(x,y)
    z = coef(1)*x^2 + coef(2)*x*y + coef(3)*y^2;
endfunction

//--------- bornes -------

x=-Rx:dx:Rx;
y=-Ry:dy:Ry;

//-------- trace surface 3D -------------
if (opt == 0)
    
    fplot3d(x,y,V);
    
    //------- options graphiques ---------
    e = gce();
    e.color_flag=1; 
    e.color_mode=-2  // remove the facets boundary by setting color_mode to white color
    a = gca(); //get current axes
    a.rotation_angles=[81,-112];
//    a.axes_visible="off";
//    a.box = "off";
    f = gcf();//get the handle of the parent figure
    f.color_map = jetcolormap(512);
end

//-------- ajouter surfaces de niveau à plot3d ---------
if (opt == 2)
    
    fplot3d(x,y,V);
    e = gce();
    e.color_flag=1; 
    e.color_mode=-2;  // remove the facets boundary by setting color_mode to white color
    f = gcf();//get the handle of the parent figure
    f.color_map = jetcolormap(512);
    
    z = feval(x,y,V);
    contour(x,y,z,20,flag=[0 2 4]);  // flag = mode/scaling/box
    f = gcf();//get the handle of the parent figure
    f.color_map = jetcolormap(512);
    a = gca(); // get current axes
    a.rotation_angles=[77.5,233];
    a.box = "off";
end

//------- trace d'un contour -----------
if (opt == 1)
    
    z = feval(x,y,V);
    contour2d(x,y,z,30,rect=[-Rx,-Ry,Rx,Ry]);
    f = gcf(); // get the handle of the parent figure
    f.color_map = jetcolormap(24);
    a = gca(); //get current axes
    a.isoview = "on";
    
end
